/*
 * Copyright (c) 2004-2007 Erez Zadok
 * Copyright (c) 2004-2007 Stony Brook University
 * Copyright (c) 2004-2007 The Research Foundation of State University of New York
 * Copyright (c) 2004-2007 Nikolai Joukov
 *
 * For specific licensing information, see the COPYING file distributed with
 * this package, or get one from ftp://ftp.filesystems.org/pub/fist/COPYING.
 *
 * This Copyright notice must be kept intact and distributed with all
 * fistgen sources INCLUDING sources generated by fistgen.
 */

#ifdef __KERNEL__
#error THIS IS A USER LEVEL APP NOT A KERNEL MODULE!!!
#endif

#include <asm/unistd.h>
#include <asm/errno.h>
#include <stdio.h>
#include <stdlib.h>

#include "replay.h"

int errno;

static inline _syscall3(int, sys_replay, const char*, replay_file, const char*, replay_mount, const int, speed);

int main(int argc, char *argv[])
{
	if ((argc != 3) || (argv[1][0] == 0) || (argv[2][0] == 0)) {
		fprintf(stderr, "Usage: %s replay_file mount_point\n", argv[0]);
		exit(EINVAL);
	}

	if(sys_replay(argv[1], argv[2], 0)) {
		perror(argv[0]);
		return(1);
	}
	exit(0);
}
