#!/usr/bin/perl
# Copyright (c) 2003-2007 Erez Zadok
# Copyright (c) 2003-2007 Stony Brook University
# Copyright (c) 2003-2007 The Research Foundation of State University of New York
# Copyright (c) 2004-2007 Nikolai Joukov
# Copyright (c) 2003-2005 Akshat Aranya
# Copyright (c) 2006-2007 Gopala Surya

use IO::Socket;

sub usage()
{
	print STDERR "Usage: trace_listener.pl <port> <output file>\n";
	exit(1);
}

if (@ARGV != 2) {
	usage();
}

$port = $ARGV[0];

open (OUTFILE, ">$ARGV[1]") or die "Could not open output file $!\n";
# open the socket and dump everything to the output file
my $pid = fork();
die "fork() failed: $!" unless defined $pid;
if ($pid) {
	close(STDIN);
	close(STDOUT);
	close(STDERR);
	exit(0);
} else {
	$sock = new IO::Socket::INET(LocalHost=>'0.0.0.0', LocalPort=>$port, Proto=>'tcp', Listen=>1, Reuse=>1);
	die "Could not create socket: $!\n" unless $sock;

	$new_sock = $sock->accept();
	while (read($new_sock, $buf, 4096) > 0) {
		print OUTFILE $buf;
	}
	close($new_sock);
	close(OUTFILE);
	close($sock);
}

